=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpPythonClient
  class ContentPackagesApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a python package content
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :sha256 The SHA256 digest of this package. (default to '')
    # @option opts [String] :summary A one-line summary of what the package does.
    # @option opts [String] :description A longer description of the package that can run to several paragraphs.
    # @option opts [String] :description_content_type A string stating the markup syntax (if any) used in the distribution’s description, so that tools can intelligently render the description.
    # @option opts [String] :keywords Additional keywords to be used to assist searching for the package in a larger catalog.
    # @option opts [String] :home_page The URL for the package&#39;s home page.
    # @option opts [String] :download_url Legacy field denoting the URL from which this package can be downloaded.
    # @option opts [String] :author Text containing the author&#39;s name. Contact information can also be added, separated with newlines.
    # @option opts [String] :author_email The author&#39;s e-mail address. 
    # @option opts [String] :maintainer The maintainer&#39;s name at a minimum; additional contact information may be provided.
    # @option opts [String] :maintainer_email The maintainer&#39;s e-mail address.
    # @option opts [String] :license Text indicating the license covering the distribution
    # @option opts [String] :requires_python The Python version(s) that the distribution is guaranteed to be compatible with.
    # @option opts [String] :project_url A browsable URL for the project and a label for it, separated by a comma.
    # @option opts [Object] :project_urls A dictionary of labels and URLs for the project.
    # @option opts [String] :platform A comma-separated list of platform specifications, summarizing the operating systems supported by the package.
    # @option opts [String] :supported_platform Field to specify the OS and CPU for which the binary package was compiled. 
    # @option opts [Object] :requires_dist A JSON list containing names of some other distutils project required by this distribution.
    # @option opts [Object] :provides_dist A JSON list containing names of a Distutils project which is contained within this distribution.
    # @option opts [Object] :obsoletes_dist A JSON list containing names of a distutils project&#39;s distribution which this distribution renders obsolete, meaning that the two projects should not be installed at the same time.
    # @option opts [Object] :requires_external A JSON list containing some dependency in the system that the distribution is to be used.
    # @option opts [Object] :classifiers A JSON list containing classification values for a Python package.
    # @return [AsyncOperationResponse]
    def create(relative_path, opts = {})
      data, _status_code, _headers = create_with_http_info(relative_path, opts)
      data
    end

    # Create a python package content
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @option opts [String] :sha256 The SHA256 digest of this package.
    # @option opts [String] :summary A one-line summary of what the package does.
    # @option opts [String] :description A longer description of the package that can run to several paragraphs.
    # @option opts [String] :description_content_type A string stating the markup syntax (if any) used in the distribution’s description, so that tools can intelligently render the description.
    # @option opts [String] :keywords Additional keywords to be used to assist searching for the package in a larger catalog.
    # @option opts [String] :home_page The URL for the package&#39;s home page.
    # @option opts [String] :download_url Legacy field denoting the URL from which this package can be downloaded.
    # @option opts [String] :author Text containing the author&#39;s name. Contact information can also be added, separated with newlines.
    # @option opts [String] :author_email The author&#39;s e-mail address. 
    # @option opts [String] :maintainer The maintainer&#39;s name at a minimum; additional contact information may be provided.
    # @option opts [String] :maintainer_email The maintainer&#39;s e-mail address.
    # @option opts [String] :license Text indicating the license covering the distribution
    # @option opts [String] :requires_python The Python version(s) that the distribution is guaranteed to be compatible with.
    # @option opts [String] :project_url A browsable URL for the project and a label for it, separated by a comma.
    # @option opts [Object] :project_urls A dictionary of labels and URLs for the project.
    # @option opts [String] :platform A comma-separated list of platform specifications, summarizing the operating systems supported by the package.
    # @option opts [String] :supported_platform Field to specify the OS and CPU for which the binary package was compiled. 
    # @option opts [Object] :requires_dist A JSON list containing names of some other distutils project required by this distribution.
    # @option opts [Object] :provides_dist A JSON list containing names of a Distutils project which is contained within this distribution.
    # @option opts [Object] :obsoletes_dist A JSON list containing names of a distutils project&#39;s distribution which this distribution renders obsolete, meaning that the two projects should not be installed at the same time.
    # @option opts [Object] :requires_external A JSON list containing some dependency in the system that the distribution is to be used.
    # @option opts [Object] :classifiers A JSON list containing classification values for a Python package.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(relative_path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.create ...'
      end
      # verify the required parameter 'relative_path' is set
      if @api_client.config.client_side_validation && relative_path.nil?
        fail ArgumentError, "Missing the required parameter 'relative_path' when calling ContentPackagesApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/python/packages/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['relative_path'] = relative_path
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?
      form_params['sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      form_params['summary'] = opts[:'summary'] if !opts[:'summary'].nil?
      form_params['description'] = opts[:'description'] if !opts[:'description'].nil?
      form_params['description_content_type'] = opts[:'description_content_type'] if !opts[:'description_content_type'].nil?
      form_params['keywords'] = opts[:'keywords'] if !opts[:'keywords'].nil?
      form_params['home_page'] = opts[:'home_page'] if !opts[:'home_page'].nil?
      form_params['download_url'] = opts[:'download_url'] if !opts[:'download_url'].nil?
      form_params['author'] = opts[:'author'] if !opts[:'author'].nil?
      form_params['author_email'] = opts[:'author_email'] if !opts[:'author_email'].nil?
      form_params['maintainer'] = opts[:'maintainer'] if !opts[:'maintainer'].nil?
      form_params['maintainer_email'] = opts[:'maintainer_email'] if !opts[:'maintainer_email'].nil?
      form_params['license'] = opts[:'license'] if !opts[:'license'].nil?
      form_params['requires_python'] = opts[:'requires_python'] if !opts[:'requires_python'].nil?
      form_params['project_url'] = opts[:'project_url'] if !opts[:'project_url'].nil?
      form_params['project_urls'] = opts[:'project_urls'] if !opts[:'project_urls'].nil?
      form_params['platform'] = opts[:'platform'] if !opts[:'platform'].nil?
      form_params['supported_platform'] = opts[:'supported_platform'] if !opts[:'supported_platform'].nil?
      form_params['requires_dist'] = opts[:'requires_dist'] if !opts[:'requires_dist'].nil?
      form_params['provides_dist'] = opts[:'provides_dist'] if !opts[:'provides_dist'].nil?
      form_params['obsoletes_dist'] = opts[:'obsoletes_dist'] if !opts[:'obsoletes_dist'].nil?
      form_params['requires_external'] = opts[:'requires_external'] if !opts[:'requires_external'].nil?
      form_params['classifiers'] = opts[:'classifiers'] if !opts[:'classifiers'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List python package contents
    #  PythonPackageContent represents each individually installable Python package. In the Python ecosystem, this is called a Python Distribution, sometimes (ambiguously) refered to as a package. In Pulp Python, we refer to it as PythonPackageContent. Each PythonPackageContent corresponds to a single filename, for example `pulpcore-3.0.0rc1-py3-none-any.whl` or `pulpcore-3.0.0rc1.tar.gz`.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :author Filter results where author matches value
    # @option opts [Array<String>] :author__in Filter results where author is in a comma-separated list of values
    # @option opts [String] :filename Filter results where filename matches value
    # @option opts [String] :filename__contains Filter results where filename contains value
    # @option opts [Array<String>] :filename__in Filter results where filename is in a comma-separated list of values
    # @option opts [String] :keywords__contains Filter results where keywords contains value
    # @option opts [Array<String>] :keywords__in Filter results where keywords is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :packagetype Filter results where packagetype matches value
    # @option opts [Array<String>] :packagetype__in Filter results where packagetype is in a comma-separated list of values
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :requires_python Filter results where requires_python matches value
    # @option opts [String] :requires_python__contains Filter results where requires_python contains value
    # @option opts [Array<String>] :requires_python__in Filter results where requires_python is in a comma-separated list of values
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [Array<String>] :sha256__in Filter results where sha256 is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedpythonPythonPackageContentResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List python package contents
    #  PythonPackageContent represents each individually installable Python package. In the Python ecosystem, this is called a Python Distribution, sometimes (ambiguously) refered to as a package. In Pulp Python, we refer to it as PythonPackageContent. Each PythonPackageContent corresponds to a single filename, for example &#x60;pulpcore-3.0.0rc1-py3-none-any.whl&#x60; or &#x60;pulpcore-3.0.0rc1.tar.gz&#x60;.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :author Filter results where author matches value
    # @option opts [Array<String>] :author__in Filter results where author is in a comma-separated list of values
    # @option opts [String] :filename Filter results where filename matches value
    # @option opts [String] :filename__contains Filter results where filename contains value
    # @option opts [Array<String>] :filename__in Filter results where filename is in a comma-separated list of values
    # @option opts [String] :keywords__contains Filter results where keywords contains value
    # @option opts [Array<String>] :keywords__in Filter results where keywords is in a comma-separated list of values
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name Filter results where name matches value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :packagetype Filter results where packagetype matches value
    # @option opts [Array<String>] :packagetype__in Filter results where packagetype is in a comma-separated list of values
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :requires_python Filter results where requires_python matches value
    # @option opts [String] :requires_python__contains Filter results where requires_python contains value
    # @option opts [Array<String>] :requires_python__in Filter results where requires_python is in a comma-separated list of values
    # @option opts [String] :sha256 Filter results where sha256 matches value
    # @option opts [Array<String>] :sha256__in Filter results where sha256 is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedpythonPythonPackageContentResponseList, Integer, Hash)>] PaginatedpythonPythonPackageContentResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.list ...'
      end
      allowable_values = ["bdist_dmg", "bdist_dumb", "bdist_egg", "bdist_msi", "bdist_rpm", "bdist_wheel", "bdist_wininst", "sdist"]
      if @api_client.config.client_side_validation && opts[:'packagetype'] && !allowable_values.include?(opts[:'packagetype'])
        fail ArgumentError, "invalid value for \"packagetype\", must be one of #{allowable_values}"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/python/packages/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'author'] = opts[:'author'] if !opts[:'author'].nil?
      query_params[:'author__in'] = @api_client.build_collection_param(opts[:'author__in'], :csv) if !opts[:'author__in'].nil?
      query_params[:'filename'] = opts[:'filename'] if !opts[:'filename'].nil?
      query_params[:'filename__contains'] = opts[:'filename__contains'] if !opts[:'filename__contains'].nil?
      query_params[:'filename__in'] = @api_client.build_collection_param(opts[:'filename__in'], :csv) if !opts[:'filename__in'].nil?
      query_params[:'keywords__contains'] = opts[:'keywords__contains'] if !opts[:'keywords__contains'].nil?
      query_params[:'keywords__in'] = @api_client.build_collection_param(opts[:'keywords__in'], :csv) if !opts[:'keywords__in'].nil?
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'packagetype'] = opts[:'packagetype'] if !opts[:'packagetype'].nil?
      query_params[:'packagetype__in'] = @api_client.build_collection_param(opts[:'packagetype__in'], :csv) if !opts[:'packagetype__in'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'requires_python'] = opts[:'requires_python'] if !opts[:'requires_python'].nil?
      query_params[:'requires_python__contains'] = opts[:'requires_python__contains'] if !opts[:'requires_python__contains'].nil?
      query_params[:'requires_python__in'] = @api_client.build_collection_param(opts[:'requires_python__in'], :csv) if !opts[:'requires_python__in'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'sha256__in'] = @api_client.build_collection_param(opts[:'sha256__in'], :csv) if !opts[:'sha256__in'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedpythonPythonPackageContentResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a python package content
    #  PythonPackageContent represents each individually installable Python package. In the Python ecosystem, this is called a Python Distribution, sometimes (ambiguously) refered to as a package. In Pulp Python, we refer to it as PythonPackageContent. Each PythonPackageContent corresponds to a single filename, for example `pulpcore-3.0.0rc1-py3-none-any.whl` or `pulpcore-3.0.0rc1.tar.gz`.
    # @param python_python_package_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PythonPythonPackageContentResponse]
    def read(python_python_package_content_href, opts = {})
      data, _status_code, _headers = read_with_http_info(python_python_package_content_href, opts)
      data
    end

    # Inspect a python package content
    #  PythonPackageContent represents each individually installable Python package. In the Python ecosystem, this is called a Python Distribution, sometimes (ambiguously) refered to as a package. In Pulp Python, we refer to it as PythonPackageContent. Each PythonPackageContent corresponds to a single filename, for example &#x60;pulpcore-3.0.0rc1-py3-none-any.whl&#x60; or &#x60;pulpcore-3.0.0rc1.tar.gz&#x60;.
    # @param python_python_package_content_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PythonPythonPackageContentResponse, Integer, Hash)>] PythonPythonPackageContentResponse data, response status code and response headers
    def read_with_http_info(python_python_package_content_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentPackagesApi.read ...'
      end
      # verify the required parameter 'python_python_package_content_href' is set
      if @api_client.config.client_side_validation && python_python_package_content_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_package_content_href' when calling ContentPackagesApi.read"
      end
      # resource path
      local_var_path = '{python_python_package_content_href}'.sub('{' + 'python_python_package_content_href' + '}', CGI.escape(python_python_package_content_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PythonPythonPackageContentResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentPackagesApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
