=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpPythonClient
  class PypiMetadataApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Get package metadata
    # Retrieves the package's core-metadata specified by https://packaging.python.org/specifications/core-metadata/. `meta` must be a path in form of `{package}/json/` or `{package}/{version}/json/`
    # @param meta [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PackageMetadataResponse]
    def read(meta, path, opts = {})
      data, _status_code, _headers = read_with_http_info(meta, path, opts)
      data
    end

    # Get package metadata
    # Retrieves the package&#39;s core-metadata specified by https://packaging.python.org/specifications/core-metadata/. &#x60;meta&#x60; must be a path in form of &#x60;{package}/json/&#x60; or &#x60;{package}/{version}/json/&#x60;
    # @param meta [String] 
    # @param path [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PackageMetadataResponse, Integer, Hash)>] PackageMetadataResponse data, response status code and response headers
    def read_with_http_info(meta, path, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: PypiMetadataApi.read ...'
      end
      # verify the required parameter 'meta' is set
      if @api_client.config.client_side_validation && meta.nil?
        fail ArgumentError, "Missing the required parameter 'meta' when calling PypiMetadataApi.read"
      end
      # verify the required parameter 'path' is set
      if @api_client.config.client_side_validation && path.nil?
        fail ArgumentError, "Missing the required parameter 'path' when calling PypiMetadataApi.read"
      end
      # resource path
      local_var_path = '/pypi/{path}/pypi/{meta}/'.sub('{' + 'meta' + '}', CGI.escape(meta.to_s).gsub('%2F', '/')).sub('{' + 'path' + '}', CGI.escape(path.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PackageMetadataResponse' 

      # auth_names
      auth_names = opts[:auth_names] || []

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: PypiMetadataApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
