=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpPythonClient
  class RepositoriesPythonApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a python repository
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param python_python_repository [PythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [PythonPythonRepositoryResponse]
    def create(python_python_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(python_python_repository, opts)
      data
    end

    # Create a python repository
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param python_python_repository [PythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(PythonPythonRepositoryResponse, Integer, Hash)>] PythonPythonRepositoryResponse data, response status code and response headers
    def create_with_http_info(python_python_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.create ...'
      end
      # verify the required parameter 'python_python_repository' is set
      if @api_client.config.client_side_validation && python_python_repository.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository' when calling RepositoriesPythonApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/python/python/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(python_python_repository) 

      # return_type
      return_type = opts[:return_type] || 'PythonPythonRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a python repository
    # Trigger an asynchronous delete task
    # @param python_python_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(python_python_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(python_python_repository_href, opts)
      data
    end

    # Delete a python repository
    # Trigger an asynchronous delete task
    # @param python_python_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(python_python_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.delete ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.delete"
      end
      # resource path
      local_var_path = '{python_python_repository_href}'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List python repositorys
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedpythonPythonRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List python repositorys
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedpythonPythonRepositoryResponseList, Integer, Hash)>] PaginatedpythonPythonRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/python/python/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedpythonPythonRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param python_python_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def modify(python_python_repository_href, repository_add_remove_content, opts = {})
      data, _status_code, _headers = modify_with_http_info(python_python_repository_href, repository_add_remove_content, opts)
      data
    end

    # Modify Repository Content
    # Trigger an asynchronous task to create a new repository version.
    # @param python_python_repository_href [String] 
    # @param repository_add_remove_content [RepositoryAddRemoveContent] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def modify_with_http_info(python_python_repository_href, repository_add_remove_content, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.modify ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.modify"
      end
      # verify the required parameter 'repository_add_remove_content' is set
      if @api_client.config.client_side_validation && repository_add_remove_content.nil?
        fail ArgumentError, "Missing the required parameter 'repository_add_remove_content' when calling RepositoriesPythonApi.modify"
      end
      # resource path
      local_var_path = '{python_python_repository_href}modify/'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_add_remove_content) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#modify\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a python repository
    # Trigger an asynchronous partial update task
    # @param python_python_repository_href [String] 
    # @param patchedpython_python_repository [PatchedpythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(python_python_repository_href, patchedpython_python_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(python_python_repository_href, patchedpython_python_repository, opts)
      data
    end

    # Update a python repository
    # Trigger an asynchronous partial update task
    # @param python_python_repository_href [String] 
    # @param patchedpython_python_repository [PatchedpythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(python_python_repository_href, patchedpython_python_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.partial_update ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.partial_update"
      end
      # verify the required parameter 'patchedpython_python_repository' is set
      if @api_client.config.client_side_validation && patchedpython_python_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patchedpython_python_repository' when calling RepositoriesPythonApi.partial_update"
      end
      # resource path
      local_var_path = '{python_python_repository_href}'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedpython_python_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a python repository
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param python_python_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PythonPythonRepositoryResponse]
    def read(python_python_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(python_python_repository_href, opts)
      data
    end

    # Inspect a python repository
    # PythonRepository represents a single Python repository, to which content can be synced, added, or removed.
    # @param python_python_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PythonPythonRepositoryResponse, Integer, Hash)>] PythonPythonRepositoryResponse data, response status code and response headers
    def read_with_http_info(python_python_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.read ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.read"
      end
      # resource path
      local_var_path = '{python_python_repository_href}'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PythonPythonRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Sync from remote
    #  Trigger an asynchronous task to sync python content. The sync task will retrieve Python content from the specified `Remote` and update the specified `Respository`, creating a new  `RepositoryVersion`.
    # @param python_python_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sync(python_python_repository_href, repository_sync_url, opts = {})
      data, _status_code, _headers = sync_with_http_info(python_python_repository_href, repository_sync_url, opts)
      data
    end

    # Sync from remote
    #  Trigger an asynchronous task to sync python content. The sync task will retrieve Python content from the specified &#x60;Remote&#x60; and update the specified &#x60;Respository&#x60;, creating a new  &#x60;RepositoryVersion&#x60;.
    # @param python_python_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sync_with_http_info(python_python_repository_href, repository_sync_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.sync ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.sync"
      end
      # verify the required parameter 'repository_sync_url' is set
      if @api_client.config.client_side_validation && repository_sync_url.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sync_url' when calling RepositoriesPythonApi.sync"
      end
      # resource path
      local_var_path = '{python_python_repository_href}sync/'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sync_url) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a python repository
    # Trigger an asynchronous update task
    # @param python_python_repository_href [String] 
    # @param python_python_repository [PythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(python_python_repository_href, python_python_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(python_python_repository_href, python_python_repository, opts)
      data
    end

    # Update a python repository
    # Trigger an asynchronous update task
    # @param python_python_repository_href [String] 
    # @param python_python_repository [PythonPythonRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(python_python_repository_href, python_python_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesPythonApi.update ...'
      end
      # verify the required parameter 'python_python_repository_href' is set
      if @api_client.config.client_side_validation && python_python_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository_href' when calling RepositoriesPythonApi.update"
      end
      # verify the required parameter 'python_python_repository' is set
      if @api_client.config.client_side_validation && python_python_repository.nil?
        fail ArgumentError, "Missing the required parameter 'python_python_repository' when calling RepositoriesPythonApi.update"
      end
      # resource path
      local_var_path = '{python_python_repository_href}'.sub('{' + 'python_python_repository_href' + '}', CGI.escape(python_python_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(python_python_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesPythonApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
