=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpPythonClient
  # A Serializer for PythonPackageContent.
  class PythonPythonPackageContentResponse
    attr_accessor :pulp_href

    # Timestamp of creation.
    attr_accessor :pulp_created

    # Artifact file representing the physical content
    attr_accessor :artifact

    # The name of the distribution package, usually of the format: {distribution}-{version}(-{build tag})?-{python tag}-{abi tag}-{platform tag}.{packagetype}
    attr_accessor :filename

    # The type of the distribution package (e.g. sdist, bdist_wheel, bdist_egg, etc)
    attr_accessor :packagetype

    # The name of the python project.
    attr_accessor :name

    # The packages version number.
    attr_accessor :version

    # The SHA256 digest of this package.
    attr_accessor :sha256

    # Version of the file format
    attr_accessor :metadata_version

    # A one-line summary of what the package does.
    attr_accessor :summary

    # A longer description of the package that can run to several paragraphs.
    attr_accessor :description

    # A string stating the markup syntax (if any) used in the distribution’s description, so that tools can intelligently render the description.
    attr_accessor :description_content_type

    # Additional keywords to be used to assist searching for the package in a larger catalog.
    attr_accessor :keywords

    # The URL for the package's home page.
    attr_accessor :home_page

    # Legacy field denoting the URL from which this package can be downloaded.
    attr_accessor :download_url

    # Text containing the author's name. Contact information can also be added, separated with newlines.
    attr_accessor :author

    # The author's e-mail address. 
    attr_accessor :author_email

    # The maintainer's name at a minimum; additional contact information may be provided.
    attr_accessor :maintainer

    # The maintainer's e-mail address.
    attr_accessor :maintainer_email

    # Text indicating the license covering the distribution
    attr_accessor :license

    # The Python version(s) that the distribution is guaranteed to be compatible with.
    attr_accessor :requires_python

    # A browsable URL for the project and a label for it, separated by a comma.
    attr_accessor :project_url

    # A dictionary of labels and URLs for the project.
    attr_accessor :project_urls

    # A comma-separated list of platform specifications, summarizing the operating systems supported by the package.
    attr_accessor :platform

    # Field to specify the OS and CPU for which the binary package was compiled. 
    attr_accessor :supported_platform

    # A JSON list containing names of some other distutils project required by this distribution.
    attr_accessor :requires_dist

    # A JSON list containing names of a Distutils project which is contained within this distribution.
    attr_accessor :provides_dist

    # A JSON list containing names of a distutils project's distribution which this distribution renders obsolete, meaning that the two projects should not be installed at the same time.
    attr_accessor :obsoletes_dist

    # A JSON list containing some dependency in the system that the distribution is to be used.
    attr_accessor :requires_external

    # A JSON list containing classification values for a Python package.
    attr_accessor :classifiers

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pulp_href' => :'pulp_href',
        :'pulp_created' => :'pulp_created',
        :'artifact' => :'artifact',
        :'filename' => :'filename',
        :'packagetype' => :'packagetype',
        :'name' => :'name',
        :'version' => :'version',
        :'sha256' => :'sha256',
        :'metadata_version' => :'metadata_version',
        :'summary' => :'summary',
        :'description' => :'description',
        :'description_content_type' => :'description_content_type',
        :'keywords' => :'keywords',
        :'home_page' => :'home_page',
        :'download_url' => :'download_url',
        :'author' => :'author',
        :'author_email' => :'author_email',
        :'maintainer' => :'maintainer',
        :'maintainer_email' => :'maintainer_email',
        :'license' => :'license',
        :'requires_python' => :'requires_python',
        :'project_url' => :'project_url',
        :'project_urls' => :'project_urls',
        :'platform' => :'platform',
        :'supported_platform' => :'supported_platform',
        :'requires_dist' => :'requires_dist',
        :'provides_dist' => :'provides_dist',
        :'obsoletes_dist' => :'obsoletes_dist',
        :'requires_external' => :'requires_external',
        :'classifiers' => :'classifiers'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'pulp_href' => :'String',
        :'pulp_created' => :'DateTime',
        :'artifact' => :'String',
        :'filename' => :'String',
        :'packagetype' => :'String',
        :'name' => :'String',
        :'version' => :'String',
        :'sha256' => :'String',
        :'metadata_version' => :'String',
        :'summary' => :'String',
        :'description' => :'String',
        :'description_content_type' => :'String',
        :'keywords' => :'String',
        :'home_page' => :'String',
        :'download_url' => :'String',
        :'author' => :'String',
        :'author_email' => :'String',
        :'maintainer' => :'String',
        :'maintainer_email' => :'String',
        :'license' => :'String',
        :'requires_python' => :'String',
        :'project_url' => :'String',
        :'project_urls' => :'Object',
        :'platform' => :'String',
        :'supported_platform' => :'String',
        :'requires_dist' => :'Object',
        :'provides_dist' => :'Object',
        :'obsoletes_dist' => :'Object',
        :'requires_external' => :'Object',
        :'classifiers' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpPythonClient::PythonPythonPackageContentResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpPythonClient::PythonPythonPackageContentResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'pulp_href')
        self.pulp_href = attributes[:'pulp_href']
      end

      if attributes.key?(:'pulp_created')
        self.pulp_created = attributes[:'pulp_created']
      end

      if attributes.key?(:'artifact')
        self.artifact = attributes[:'artifact']
      end

      if attributes.key?(:'filename')
        self.filename = attributes[:'filename']
      end

      if attributes.key?(:'packagetype')
        self.packagetype = attributes[:'packagetype']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'sha256')
        self.sha256 = attributes[:'sha256']
      else
        self.sha256 = ''
      end

      if attributes.key?(:'metadata_version')
        self.metadata_version = attributes[:'metadata_version']
      end

      if attributes.key?(:'summary')
        self.summary = attributes[:'summary']
      end

      if attributes.key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.key?(:'description_content_type')
        self.description_content_type = attributes[:'description_content_type']
      end

      if attributes.key?(:'keywords')
        self.keywords = attributes[:'keywords']
      end

      if attributes.key?(:'home_page')
        self.home_page = attributes[:'home_page']
      end

      if attributes.key?(:'download_url')
        self.download_url = attributes[:'download_url']
      end

      if attributes.key?(:'author')
        self.author = attributes[:'author']
      end

      if attributes.key?(:'author_email')
        self.author_email = attributes[:'author_email']
      end

      if attributes.key?(:'maintainer')
        self.maintainer = attributes[:'maintainer']
      end

      if attributes.key?(:'maintainer_email')
        self.maintainer_email = attributes[:'maintainer_email']
      end

      if attributes.key?(:'license')
        self.license = attributes[:'license']
      end

      if attributes.key?(:'requires_python')
        self.requires_python = attributes[:'requires_python']
      end

      if attributes.key?(:'project_url')
        self.project_url = attributes[:'project_url']
      end

      if attributes.key?(:'project_urls')
        self.project_urls = attributes[:'project_urls']
      end

      if attributes.key?(:'platform')
        self.platform = attributes[:'platform']
      end

      if attributes.key?(:'supported_platform')
        self.supported_platform = attributes[:'supported_platform']
      end

      if attributes.key?(:'requires_dist')
        self.requires_dist = attributes[:'requires_dist']
      end

      if attributes.key?(:'provides_dist')
        self.provides_dist = attributes[:'provides_dist']
      end

      if attributes.key?(:'obsoletes_dist')
        self.obsoletes_dist = attributes[:'obsoletes_dist']
      end

      if attributes.key?(:'requires_external')
        self.requires_external = attributes[:'requires_external']
      end

      if attributes.key?(:'classifiers')
        self.classifiers = attributes[:'classifiers']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pulp_href == o.pulp_href &&
          pulp_created == o.pulp_created &&
          artifact == o.artifact &&
          filename == o.filename &&
          packagetype == o.packagetype &&
          name == o.name &&
          version == o.version &&
          sha256 == o.sha256 &&
          metadata_version == o.metadata_version &&
          summary == o.summary &&
          description == o.description &&
          description_content_type == o.description_content_type &&
          keywords == o.keywords &&
          home_page == o.home_page &&
          download_url == o.download_url &&
          author == o.author &&
          author_email == o.author_email &&
          maintainer == o.maintainer &&
          maintainer_email == o.maintainer_email &&
          license == o.license &&
          requires_python == o.requires_python &&
          project_url == o.project_url &&
          project_urls == o.project_urls &&
          platform == o.platform &&
          supported_platform == o.supported_platform &&
          requires_dist == o.requires_dist &&
          provides_dist == o.provides_dist &&
          obsoletes_dist == o.obsoletes_dist &&
          requires_external == o.requires_external &&
          classifiers == o.classifiers
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [pulp_href, pulp_created, artifact, filename, packagetype, name, version, sha256, metadata_version, summary, description, description_content_type, keywords, home_page, download_url, author, author_email, maintainer, maintainer_email, license, requires_python, project_url, project_urls, platform, supported_platform, requires_dist, provides_dist, obsoletes_dist, requires_external, classifiers].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpPythonClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
